<?php
/**
 * Order Item Details
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/order/order-details-item.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 3.7.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! apply_filters( 'woocommerce_order_item_visible', true, $item ) ) {
	return;
     

}
?>
<tr class="<?php echo esc_attr( apply_filters( 'woocommerce_order_item_class', 'woocommerce-table__line-item order_item', $item, $order ) ); ?>">




	<td class="woocommerce-table__product-name product-name">




		<?php
		$is_visible        = $product && $product->is_visible();
		$product_permalink = apply_filters( 'woocommerce_order_item_permalink', $is_visible ? $product->get_permalink( $item ) : '', $item, $order );

		
	

		echo apply_filters( 'woocommerce_order_item_name', $product_permalink ? sprintf( '<a href="%s">%s</a>', $product_permalink, $item->get_name() ) : $item->get_name(), $item, $is_visible ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

		$qty          = $item->get_quantity();
		$refunded_qty = $order->get_qty_refunded_for_item( $item_id );

		if ( $refunded_qty ) {
			$qty_display = '<del>' . esc_html( $qty ) . '</del> <ins>' . esc_html( $qty - ( $refunded_qty * -1 ) ) . '</ins>';
		} else {
			$qty_display = esc_html( $qty );
		}

		echo apply_filters( 'woocommerce_order_item_quantity_html', ' <strong class="product-quantity">' . sprintf( '&times;&nbsp;%s', $qty_display ) . '</strong>', $item ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
      
		do_action( 'woocommerce_order_item_meta_start', $item_id, $item, $order, false );

        
		wc_display_item_meta( $item ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
        
		do_action( 'woocommerce_order_item_meta_end', $item_id, $item, $order, false );
		?>
	</td>

	<td class="woocommerce-table__product-total product-total">
		<?php //echo $order->get_quantity( $item ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

        
        echo $qty ." ";

      // echo  $item_id;

       global $wpdb;
         
    $table_prefix=$wpdb->prefix;

   $query1 = "SELECT * FROM ".$table_prefix."wc_order_product_lookup WHERE order_item_id ='$item_id' ";

   //echo  $query1;

  $lineItems=$wpdb->get_results($query1);


if(!empty($lineItems)){
  $productid=[];
  foreach ($lineItems as $key => $lineItem) {

    $productid = $lineItem->product_id;

  }

  //print_r($productid);

  //die();

  $query1 = "SELECT * FROM ".$table_prefix."postmeta WHERE post_id ='$productid' and  meta_key ='_inve_unit' ";

   //echo  $query2;

   $productinfo=$wpdb->get_results($query1);

    foreach ($productinfo as $key => $productitem) {

    echo $productitem->meta_value;

  }

}
    
	     ?>
	</td>

<td><?php

$query1 = "SELECT * FROM ".$table_prefix."woocommerce_order_itemmeta WHERE order_item_id ='$item_id' and  meta_key ='_line_total' ";

//echo $query1;
 $linetotal=$wpdb->get_results($query1);

    foreach ($linetotal as $key => $productotal) {

    $prototal =  $productotal->meta_value;
}

echo get_woocommerce_currency_symbol();

 echo $prototal / $qty ; ?>
 	


 </td>

 <td>

      <?php echo get_woocommerce_currency_symbol(). $prototal;?>

 </td>

</tr>

<?php if ( $show_purchase_note && $purchase_note ) : ?>

<tr class="woocommerce-table__product-purchase-note product-purchase-note">

	<td colspan="2"><?php echo wpautop( do_shortcode( wp_kses_post( $purchase_note ) ) ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?></td>

</tr>

<?php endif; ?>
